=== debian/changelog ===
arm-compute-library (23.08+dfsg-2) unstable; urgency=medium

  * Source-only upload.
  * Set Standards-Versions to 4.6.2.

 -- Emanuele Rocca <ema@debian.org>  Mon, 28 Aug 2023 10:50:09 +0200

arm-compute-library (23.08+dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #1049869)
  * Rename binary package to libarm-compute32 for soname bump.
  * Build on amd64 as well.
  * Split assembler block in a32_merge_float_8x6.hpp to fix FTBFS on armhf.
  * Build with buildsystem=none.
  * Drop gles_compute from scons arguments.
  * Build with debug=1 to include debug symbols.
  * Drop libarm_compute_core, now an empty dummy library.
  * Set debhelper compatibility level to 13 to get dh_install variable
    expansion without dh-exec. Drop build-dependency on dh-exec.
  * Add debian/README.source.
  * debian/watch: add dversionmangle for +dfsg suffix.

 -- Emanuele Rocca <ema@debian.org>  Thu, 24 Aug 2023 20:15:14 +0200
